unit DownSampling;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,Series, TeeDownSampling, Math,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, Vcl.ExtCtrls, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm2 = class(TForm)
    Chart1: TChart;
    procedure FormCreate(Sender: TObject);
    procedure ChartZoom;
    procedure ChartUndoZoom;
    procedure CalcTolerance;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.dfm}

var oSeries, dSeries: TFastLineSeries;
    dFunc: TDownSamplingFunction;
    minSector: Integer;

procedure TForm2.FormCreate(Sender: TObject);
var i: Integer;
begin
  Chart1.View3D:=False;
  Chart1.Legend.Hide;

  Chart1.Axes.Bottom.Grid.Hide;
  Chart1.Axes.Left.Grid.Hide;
  Chart1.Axes.Left.SetMinMax(0,2000);

  oSeries:=Chart1.AddSeries(TFastLineSeries) as TFastLineSeries;
  with oSeries do
  begin
    Pen.Style:=psDash;

    Add(1000);
    for i:=0 to 400-1 do
      Add(YValue[Count-1]+Random*10-5);

    Active:=False;
  end;

  dSeries:=Chart1.AddSeries(TFastLineSeries) as TFastLineSeries;
  dFunc:=TDownSamplingFunction.Create(Self);
  dFunc.DownSampleMethod:=dsAverage;
  dSeries.SetFunction(dFunc);
  dSeries.Pen.Style:=oSeries.Pen.Style;
  dSeries.Color:=oSeries.Color;
  dSeries.DataSource:=oSeries;
  dSeries.CheckDataSource;

  Chart1.OnZoom:=ChartZoom;
  Chart1.OnUndoZoom:=ChartUndoZoom;

  CalcTolerance;
end;


procedure TForm2.ChartZoom(Sender: TObject);
begin
  CalcTolerance;
end;

procedure TForm2.ChartUndoZoom(Sender: TObject);
begin
  CalcTolerance;
end;

procedure TForm2.CalcTolerance;
begin
  dFunc.Tolerance:=1;
  Chart1.Draw;

  if dSeries.Count>0 then
    while (Chart1.ChartRect.Right-Chart1.ChartRect.Left) div (dSeries.LastDisplayedIndex-dSeries.FirstDisplayedIndex) < 5 do
    begin
      dFunc.Tolerance:=dFunc.Tolerance+1;
      dSeries.CalcFirstLastVisibleIndex;
    end;

  Caption:=FormatFloat('#,##0', dFunc.Tolerance);
end;

end.